/** Class ModelMerge implements the actual model merging algorithm
  use this to implement the algorithm as indicated in the hand-out.
  
  This class also houses the "main" method with which one should
  be able to test your program with.
*/

class ModelMerge{
    Grammar g;
    boolean printGrammar;
    double alpha;
    
    /** the constructor*/
    ModelMerge(String datafile, boolean printGrammar, double alpha){
        Vector sentences = Data.getData(datafile);
        // ... fill in here ...
    }

    /** Run the model merge algorithm, calling the appropriate methods in
     * Grammar.java. */
    void run(){

    }

    //the calling convention for this program is
    //arg 0: filename of data file
    //arg 1: "printYes" or "printNo" indicating whether 
    //       the grammar should be printed after each merge using
    //       printGrammar() provided in the Grammar class
    //arg 2: alpha for the cost function

    //example call to the program
    //java ModelMerge <filename> printYes <alpha>
    public static void main(String[] args){
        String datafile = null;
        boolean printGrammar = false;
        double alpha = 1;

        // parse args
        try {
            // right # args
            if (args.length!=3)
                argFail();
            // datafile
            datafile = args[0];
            // printGrammar
            if (args[1].equals("printYes"))
                printGrammar = true;
            else if (args[1].equals("printNo"))
                printGrammar = false;
            else
                argFail();
            // alpha
            alpha = Double.parseDouble(args[2]);
        } catch (Exception e) {
            argFail();
        }

        ModelMerge mm = new ModelMerge(datafile, printGrammar, alpha);
        mm.run();
    }

    /** Print an argument error message and exit. */
    public static void argFail() {
        System.err.println("usage: java ModelMerge <filename> <printYes/printNo> <alpha>");
        System.exit(2);
    }
}

    
